<?php
// *******************************************************
//
// SambaPOS4 DB Operations Tool
//
// *******************************************************
// v3.2 (2015-05-13) QMcKay
//  - adding setting for default_charset using UTF-8
// v3.1 (2015-04-13) QMcKay
//  - changed PHP filename to dbops.php
//  - added auto-create WorkPeriod
//  - added auto-create Menu
//  - added more error checking
//  - added ExecQuery function to encapsulate Query Execution and error handling
//  - added separate functions (ops) and split into separate files:
//     - dbops_deleteproducts.php
//     - dbops_deletetransactions.php
//     - dbops_importproducts.php
//     - dbops_readproducts.php
//     - dbops_functions.php
// v3.0 (2015-04-10) QMcKay
//  - supports changes in DB up to SambaPOS 4.1.82
// v2.0 (8/06/2014) John Sheather
//  - supports changes in DB up to DambaPOS 4.1.37
// v1.0 Created by John Sheather
// *******************************************************
// Developed and Tested using WAMPServer 2.5 32bit
// http://www.wampserver.com/en/#download-wrapper
//
// Component Versions used
// Apache 2.4.9
// PHP 5.5.12
// PHP 5.6.0 (QMcKay)
// MYSQL 5.6.17 (not required)
// *******************************************************


// *******************************************************
// User Settings
// *******************************************************
//
// the driver version depends on your SQL installation
// SQL Express 2012 is v10
// SQL Express 2014 is v11
//$driver = "{SQL Server Native Client 10.0}";
$driver = "{SQL Server Native Client 11.0}";

// SQL Express Server Details - Set from your connection string, for example:
// data source = localhost\SAMBAPOS; user id=sa; password=sambapos; database=import
$myServer = "localhost\SQLEXPRESS";
$myUser = "sa";
$myPass = "sambapos";
$myDB = "import"; 

// file containing Product Data
$myImportFile = "import.csv";

// Timezone - http://php.net/manual/en/timezones.php
// date_default_timezone_set('Australia/Sydney');
date_default_timezone_set('Canada/Saskatchewan');

// Menu Defaults
// Colours can be by Name or by Hex RGB Code (#AAFF00) - http://colorschemedesigner.com/
$DefaultCategoryButtonColour = "Orange";
$DefaultMenuItemButtonColour = "Green";

$CategoryButtonHeight = "75";
$SubCategoryButtonHeight = "75";
$MenuItemButtonHeight = "75";

$DefaultColumnCount = "0"; // 0-defaults to 3 columns
$DefaultNumberPad = "2"; // 2-Large, 1-Small, 0-None

$MenuButtonLength = 32; // Creates automatic Product Name wrapping on Menu Button 


//E_ALL & ~E_DEPRECATED & ~E_STRICT
error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT);
ini_set("display_errors", 1);

// character set
// PHP's default character set is set to empty.
// http://php.net/default-charset
ini_set("default_charset","UTF-8");

// *******************************************************
// End of user settings
// *******************************************************



ini_set("auto_detect_line_endings", 1);
include ("dbops_functions.php");

$op = $_GET["op"];
if ($op!='importproducts' && $op!='readproducts' && $op!='deleteproducts' && $op!='deletetransactions') {
    $op='';
}

echo '<!DOCTYPE html>'."\r\n";
echo '<html>'."\r\n";
echo '<head>'."\r\n";
echo '<title>SambaPOS DBops</title>'."\r\n";
?>
<SCRIPT language="Javascript" type="text/javascript">
function verifyop(op) {
    var execop = confirm("Are you certain you want to "+op+" ?");
    if (execop==true) {
        op = op.toLowerCase();
        op = op.replace(" ","");
        location.href='dbops.php?op='+op;
    }
}
</SCRIPT>
<?php
echo '</head>'."\r\n";
echo '<body>'."\r\n";

echo '<DIV style="display:block;width:100%">'."\r\n";

echo '<DIV style="display:inline-block;width:25%">'."\r\n";
echo '<b style="font-size:20px"><a href="#" onclick="verifyop('."'IMPORT Products'".');">IMPORT</a> Products</b><br />'."\r\n";
echo '<i>Imports Products, Menu Items, Inventory from CSV file.</i>'."\r\n";
echo '</DIV>'."\r\n";
echo '<DIV style="display:inline-block;width:25%">'."\r\n";
echo '<b style="font-size:20px"><a href="#" onclick="verifyop('."'READ Products'".');">READ</a> Products</b><br />'."\r\n";
echo '<i>Reads Products, Menu Items, Inventory from Database.</i>'."\r\n";
echo '</DIV>'."\r\n";
echo '<DIV style="display:inline-block;width:24%">'."\r\n";
echo '<b style="font-size:20px"><a href="#" onclick="verifyop('."'DELETE Products'".');">DELETE</a> Products</b><br />'."\r\n";
echo '<i>DELETES Products, Menu Items, Inventory from Database</i>'."\r\n";
echo '</DIV>'."\r\n";
echo '<DIV style="display:inline-block;width:24%">'."\r\n";
echo '<b style="font-size:20px"><a href="#" onclick="verifyop('."'DELETE Transactions'".');">DELETE</a> Transactions</b><br />'."\r\n";
echo '<i>DELETES all Transactions (i.e. Sales) from Database.</i>'."\r\n";
echo '</DIV>'."\r\n";

echo '</DIV>'."\r\n";

echo '<hr />'."\r\n";

if ($op=='') {
    goto theend;
}

echo 'OP: <b>'.$op."</b><br /><br />\r\n";




// Todays Date/Time
$today = date("Y-m-d H:i:s");
$smtime = microtime(true);
list($s,$us) = explode('.',$smtime);
$start_time = date("H:i:s.").$us; 
echo "Start : ".$start_time."<br />";

//connection to MSSQL database
$dbhandle = odbc_connect("Driver=$driver;Server=$myServer;Database=$myDB;", $myUser, $myPass)
  or die("Couldn't connect to SQL Server on $myServer because:<br />".  odbc_errormsg()); 
//echo 'Connected successfully - MSSQL<br /><br />';



// *******************************************************
// READ Products
// *******************************************************

if ($op=='readproducts') {
    include ("dbops_$op.php");
}



// *******************************************************
// DELETE Products
// *******************************************************

if ($op=='deleteproducts') {
    include ("dbops_$op.php");
}



// *******************************************************
// DELETE Transactions
// *******************************************************

if ($op=='deletetransactions') {
    include ("dbops_$op.php");
}



// *******************************************************
// IMPORT Products
// *******************************************************

if ($op=='importproducts') {
    include ("dbops_$op.php");
}
    


finish:

$emtime = microtime(true);
list($s,$us) = explode('.',$emtime);
$finish_time = date("H:i:s.").$us; 
echo '<hr />';
echo "<br />Finish : ".$finish_time;
$time1 = strtotime($start_time);
$time2 = strtotime($finish_time);
//$diff = $time2 - $time1;
$diff = $emtime-$smtime;
//echo "<br />Execution Time : ".date('i:s.u', $diff);
echo "<br />Execution Time (s): ".$diff;

theend:

//close DB connection
if ($dbhandle) {
    odbc_close($dbhandle);
}

echo '</body>'."\r\n";
echo '</html>'."\r\n";
